//****************************************************************************
//
// File         : camera.h
//
// Description  : Camera control header file.
//                Written by Lars Andersson (lars_and@algonet.se), 1998
//
//****************************************************************************

#ifndef CAMERA_H
#define CAMERA_H

#include "matrix.h"

#define TICKS_PER_FRAME 32768

typedef struct {
    int         sector;
    float       movespeed, strafespeed, lookspeed, mousespeed;
    float       acceleration, gravity, friction;
    Vertice_3D  location;
    Matrix_4x4  cmatrix;
} Camera;

void Set_Camera(Camera *cam);
void Init_Interface();

void Update_Rocket(void);
void Update_Ship(void);

#endif
