//****************************************************************************
//
// File         : fpu.h
//
// Description  : Misc FPU functions and macros.
//                Written by Lars Andersson (lars_and@algonet.se), 1998
//
//****************************************************************************

#ifndef FPU_H
#define FPU_H

void Float2Int(int *d, float f);
int Double2Int(double f);

#define FIST_MAGIC ((((65536.0 * 65536.0 * 16)+(65536.0 * 0.5))* 65536.0))
inline int Double2Int(double f)
{
  double dtemp = FIST_MAGIC + f;
  return ((*(int *)&dtemp) - 0x80000000);
}

//--- Watcom C/C++ inline asm -----------------------------------------------

#ifdef COMP_WCC
/*
#pragma aux Float2Int=\
                "push  eax                "\
                "fld   dword ptr [esp]    "\
                "fistp dword ptr [esp]    "\
                "pop   eax                "\
                parm[eax]                  \
                value[eax];
*/
#pragma aux Float2Int=\
        "fistp DWORD [eax]"\
        parm nomemory [eax] [8087]\
        modify exact [8087];

#endif

//--- DJGPP/GCC inline asm --------------------------------------------------

#if defined(COMP_DJGPP) || defined(COMP_GCC)

#define Float2Int(d, f) *d = (int)(f)

/*
#define Float2Int(d, f) \
__asm__("fistpl (%%eax)    \n\t"\
        :                     \
        : "a" (d), "f" (f)    \
        : "memory"")

        parm nomemory [eax] [8087]\
        modify exact [8087];





  int tmp;

  asm ("pushl   %%eax              \n\t"
       "fldl    (esp)              \n\t"
       "fistpl  (esp)              \n\t"
       "popl    %%eax                  "
       : "=a" (tmp)
       : "a" (f)
       : "%edx");

  return(tmp);
}
*/
#endif

#endif
