//****************************************************************************
//
// File        : timer.h
//
// Description : Header file for timer.cpp
//               Written by Lars Andersson (lars_and@algonet.se), 1997.
//
//****************************************************************************

#ifndef TIMER_H
#define TIMER_H

#if defined(COMP_WCC)
    #define TICKS_PER_SECOND 1193181
#endif

#if defined(COMP_DJGPP)
    #include <time.h>
    #define TICKS_PER_SECOND UCLOCKS_PER_SEC
#endif

#if defined(OS_LINUX)
    #define TICKS_PER_SECOND 1000000
#endif

void    Init_Timer(void);
void    Remove_Timer(void);
void    Reset_Timer(void);
unsigned long Read_Timer(void);
unsigned long Elapsed_Ticks(void);

#endif
