//****************************************************************************
//
// File         : main.h
//
// Description  : Main engine include file.
//                Written by Lars Andersson (lars_and@algonet.se), 1998
//
//****************************************************************************

#ifndef MAIN_H
#define MAIN_H

#ifndef ENGINE_H
#include "engine.h"
#endif

#ifndef SCREEN_H
#include "screen.h"
#endif

#ifndef MATRIX_H
#include "matrix.h"
#endif

#ifndef CAMERA_H
#include "camera.h"
#endif

#ifndef VECTOR_H
#include "vector.h"
#endif

#ifndef FPU_H
#include "fpu.h"
#endif

#if defined(OS_DOS) && defined(COMP_WCC)
#define R3DVERSION "DOS/Watcom Version 0.1a"
#endif

#if defined(OS_DOS) && defined(COMP_DJGPP)
#define R3DVERSION "DOS/DJGPP Version 0.1a"
#endif

#if defined(OS_LINUX) && defined(SVGALIB)
#define R3DVERSION "Linux/SVGALib Version 0.1a"
#endif

#if defined(OS_LINUX) && defined(X11)
#define R3DVERSION "Linux/X11 Version 0.1a"
#endif


#define STARTUPMESSAGE "Roketz 3D Engine - " R3DVERSION

#ifdef COMP_GCC

#define StrUppercase(str) \
__asm__("1:			\n\t"\
	" cmpb  $0, (%%esi)	\n\t"\
	" jz	3f		\n\t"\
	" cmpb	$'a', (%%esi)   \n\t"\
	" jl    2f		\n\t"\
	" cmpb  $'z', (%%esi)   \n\t"\
	" ja    2f	        \n\t"\
	" subb  $32, (%%esi)	\n\t"\
	"2:			\n\t"\
	" inc   %%esi		\n\t"\
	" jmp   1b		\n\t"\
	"3: 			    "\
	:			     \
	: "S" (&str)		     \
	: "%esi")		     


#else

#define StrUppercase(str) strupr(str)

#endif

//--- Misc constants --------------------------------------------------------

#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE -1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef PI
#define PI 3.14159265358979323
#endif

#define VIEWER_DISTANCE 200
#define NEAR_CLIP 0.01
#define VERY_SMALL 0.000001

#define DEG2RAD(x) (x * PI / 180)
#define ABS(x) ((x)<0?-(x):(x))

extern Engine engine;               // Make engine structure global...

#endif

