//****************************************************************************
//
// File         : matrix.h
//
// Description  : Matrix header file.
//                Written by Lars Andersson (lars_and@algonet.se), 1998
//
//****************************************************************************

#ifndef MATRIX_H
#define MATRIX_H

#ifndef VERTEX_H
#include "vector.h"
#endif

typedef float Matrix_4x4[4][4];

//--- Function declarations -------------------------------------------------

void    Mat_Identity_4x4(Matrix_4x4 m);

void    Mat_Mul_1x4(Vector_3D v1, Vector_3D v2, Matrix_4x4 m);
void    Mat_Mul_4x4(Matrix_4x4 r, Matrix_4x4 m1, Matrix_4x4 m2);
void    Mat_Concatenate_1x4(Vector_3D v, Matrix_4x4 m);
void    Mat_Concatenate_4x4(Matrix_4x4 md, Matrix_4x4 ms);

void    Mat_Print_4x4(Matrix_4x4 m);

#endif

