//****************************************************************************
//
// File         : poly.h
//
// Description  : Polygon rendering header file.
//                Written by Lars Andersson (lars_and@algonet.se), 1998
//
//****************************************************************************

#ifndef POLY_H
#define POLY_H

//--- Quick Pentium optimized HLine routine ---------------------------------

void Hline(char *dest, int len, int color);

//--- Watcom C/C++ inline asm -----------------------------------------------

#ifdef COMP_WCC

#pragma aux Hline=\
               "test  edi, 1         "\
               "jz    NoByte         "\
               "mov   [edi], al      "\
               "dec   ecx            "\
               "jz    Done           "\
               "inc   edi            "\
           "NoByte:                  "\
               "test  edi, 2         "\
               "jz    NoWord         "\
               "sub   ecx, 2         "\
               "js    LastByte       "\
               "mov   [edi], ax      "\
               "jz    Done           "\
               "add   edi, 2         "\
            "NoWord:                 "\
               "mov   ebx, ecx       "\
               "shr   ecx, 2         "\
               "jz    NoFill         "\
            "DFill:                  "\
               "mov   [edi], eax     "\
               "add   edi, 4         "\
               "dec   ecx            "\
               "jnz   DFill          "\
            "NoFill:                 "\
               "test  ebx, 2         "\
               "jz    NoWordLeft     "\
               "mov   [edi], ax      "\
               "add   edi, 2         "\
            "NoWordLeft:             "\
               "test  ebx, 1         "\
               "jz    Done           "\
            "LastByte:               "\
               "mov   [edi], al      "\
            "Done:                   "\
              parm [edi] [ecx] [eax] \
              modify [edi ecx ebx];

#endif

//--- DJGPP/GCC inline asm --------------------------------------------------

#if defined(COMP_DJGPP) || defined(COMP_GCC)

#define Hline(dest, len, color) \
__asm__ (" testl  $1, %%edi        \n\t"\
         " jz     1f               \n\t"\
         " movb   %%al, (%%edi)    \n\t"\
         " decl   %%ecx            \n\t"\
         " jz     7f               \n\t"\
         " incl   %%edi            \n\t"\
    "1:                            \n\t"\
         " testl  $2, %%edi        \n\t"\
         " jz     2f               \n\t"\
         " subl   $2, %%ecx        \n\t"\
         " js     6f               \n\t"\
         " movw   %%ax, (%%edi)    \n\t"\
         " jz     7f               \n\t"\
         " addl   $2, %%edi        \n\t"\
    "2:                            \n\t"\
         " movl   %%ecx, %%ebx     \n\t"\
         " shrl   $2, %%ecx        \n\t"\
         " jz     4f               \n\t"\
    "3:                            \n\t"\
         " movl   %%eax, (%%edi)   \n\t"\
         " addl   $4, %%edi        \n\t"\
         " decl   %%ecx            \n\t"\
         " jnz    3b               \n\t"\
    "4:                            \n\t"\
         " testl  $2, %%ebx        \n\t"\
         " jz     5f               \n\t"\
         " movw   %%ax, (%%edi)    \n\t"\
         " addl   $2, %%edi        \n\t"\
    "5:                            \n\t"\
         " test   $1, %%ebx        \n\t"\
         " jz     7f               \n\t"\
    "6:                            \n\t"\
         " movb   %%al, (%%edi)    \n\t"\
    "7:                            \n\t"\
         :                              \
         : "D" (dest), "c" (len), "a" (color) \
         : "%ebx", "%ecx", "%edx", "%esi", "%edi")

#endif

//--- Function declarations -------------------------------------------------

void Draw_FlatPolygon(Vertice_2DI *coord, int points, int color);
void Draw_SPTextPolygon(Vertice_2DI *coord, int points, TPlane *tp);

#endif
