//****************************************************************************
//
// File        : timer.cpp
//
// Description : DOS/Watcom Protected mode 1193181 Hz timer routines.
//               Written by Lars Andersson (lars_and@algonet.se), 1997.
//
//****************************************************************************

#include <conio.h>

#include "timer.h"

int installed, micros;

//--- Read timer value ------------------------------------------------------

unsigned long Read_Time(void);
#pragma aux Read_Time=\
                     "cli               ",\
                     "mov   dx, 20h     ",\
                     "mov   al, 0ah     ",\
                     "out   dx, al      ",\
                     "xor   al, al      ",\
                     "out   043h, al    ",\
                     "in    al, dx      ",\
                     "mov   edi, eax    ",\
                     "in    al, 40h     ",\
                     "mov   bl, al      ",\
                     "in    al, 40h     ",\
                     "mov   bh, al      ",\
                     "not   ebx         ",\
                     "in    al, 21h     ",\
                     "mov   esi, eax    ",\
                     "mov   al, 0ffh    ",\
                     "out   21h, al     ",\
                     \
                     "mov   ebp, 046ch  ",\
                     "mov   dx, [ebp]   ",\
                     "mov   eax, esi    ",\
                     "out   21h, al     ",\
                     "sti",\
                     \
                     "test  edi, 1      ",\
                     "jz    Done        ",\
                     "cmp   bx, 0ffh    ",\
                     "ja    Done        ",\
                     "inc   dx          ",\
               "Done:",\
                     "shl   edx,16      ",\
                     "mov   dx, bx      ",\
                     modify [eax ebx edx edi esi ebp] value [edx];


void Init_Timer(void)
{
    outp(0x43, 0x34);
    outp(0x40, 0);
    outp(0x40, 0);
    installed = -1;
}

void Remove_Timer(void)
{
    if (installed) {
        outp(0x43, 0x36);
        outp(0x40, 0);
        outp(0x40, 0);
    }
}

void Reset_Timer(void)
{
    micros = Read_Time();
}

unsigned long Read_Timer(void)
{
    return(Read_Time());
}

unsigned long Elapsed_Ticks(void)
{
    return(Read_Time() - micros);
}
